import { Bit } from '../types/bit';
import { Mask } from './mask';
declare enum CellType {
    Ordinary = -1,
    PrunedBranch = 1,
    LibraryReference = 2,
    MerkleProof = 3,
    MerkleUpdate = 4
}
interface CellOptions {
    bits?: Bit[];
    refs?: Cell[];
    type?: CellType;
}
declare class Cell {
    private _bits;
    private _refs;
    private _type;
    private mask;
    private hashes;
    private depths;
    constructor(options?: CellOptions);
    get bits(): Bit[];
    get refs(): Cell[];
    get type(): CellType;
    get exotic(): boolean;
    getRefsDescriptor(mask?: Mask): Bit[];
    getBitsDescriptor(): Bit[];
    getDepthDescriptor(depth: number): Bit[];
    getAugmentedBits(): Bit[];
    print(indent?: number): string;
    hash(level?: number): string;
    depth(level?: number): number;
    eq(cell: Cell): boolean;
    private validatePrunedBranch;
    private validateLibraryReference;
    private validateMerkleProof;
    private validateMerkleUpdate;
    private initialize;
}
export { Cell, CellType, CellOptions };
