"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Mask = void 0;
class Mask {
    constructor(mask) {
        this._value = mask instanceof Mask
            ? mask.value
            : mask;
    }
    get value() {
        return this._value;
    }
    get level() {
        let mask = this._value & 7;
        for (let i = 0; i <= 3; i++) {
            if (!mask)
                return i;
            mask = mask >> 1;
        }
        return 3;
    }
    get hashIndex() {
        return Mask.countBits(this._value);
    }
    get hashCount() {
        return this.hashIndex + 1;
    }
    apply(level) {
        return new Mask(this._value & ((1 << level) - 1));
    }
    isSignificant(level) {
        return level === 0 || ((this._value >> (level - 1)) % 2 !== 0);
    }
    static countBits(n) {
        n = n - ((n >> 1) & 0x55555555);
        n = (n & 0x33333333) + ((n >> 2) & 0x33333333);
        return ((n + (n >> 4) & 0xF0F0F0F) * 0x1010101) >> 24;
    }
}
exports.Mask = Mask;
//# sourceMappingURL=mask.js.map