import { KeyPair } from './key-pair';
interface MnemonicOptions {
    salt?: string;
    rounds?: number;
    keyLength?: number;
}
declare class MnemonicBIP39 {
    private _words;
    private _seed;
    private _keys;
    constructor(mnemonic?: string[], options?: MnemonicOptions);
    get words(): string[];
    get seed(): Uint8Array;
    get keys(): KeyPair;
    static genereteWords(): string[];
    static generateKeyPair(seed: Uint8Array): KeyPair;
    static genereteSeed(mnemonic: string[], salt?: any, rounds?: number, keyLength?: number): Uint8Array;
    static genereteSeedAsync(mnemonic: string[], salt?: any, rounds?: number, keyLength?: number): Promise<Uint8Array>;
    protected generateSalt(salt?: string): string;
}
export { MnemonicBIP39, MnemonicOptions };
